// u_51_class_inheritance_constraint
// 2013-02-09

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_51_class_inheritance_constraint;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Vcl.Grids;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    exit_: TButton;
    clear_: TButton;
    Panel3: TPanel;
    Memo1: TMemo;
    move_controls_left_: TButton;
    create_control_list_: TButton;
    Panel4: TPanel;
    Splitter2: TSplitter;
    Edit1: TEdit;
    CheckBox1: TCheckBox;
    StringGrid1: TStringGrid;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure move_controls_left_Click(Sender: TObject);
    procedure create_control_list_Click(Sender: TObject);
    procedure eClick(Sender: TObject);
    procedure dClick(Sender: TObject);
    procedure cClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation
  uses u_display_simple, u_c_wincontrol_list;

    {$R *.dfm}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        Left:= 170; Top:= 110;
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        Memo1.Lines.Clear;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    // -- using

    var g_c_wincontrol_list: c_wincontrol_list<tWinControl> ;

    procedure TForm1.create_control_list_Click(Sender: TObject);
      begin
        g_c_wincontrol_list:= c_wincontrol_list<tWinControl>.Create ;
        g_c_wincontrol_list.Add(Edit1);
        g_c_wincontrol_list.Add(CheckBox1);
        g_c_wincontrol_list.Add(StringGrid1);
      end; // create_control_list_Click

    procedure TForm1.move_controls_left_Click(Sender: TObject);
      begin
        g_c_wincontrol_list.move_left(5);
      end; // move_controls_left_Click

    procedure TForm1.cClick(Sender: TObject);
      begin
      end; //

    procedure TForm1.dClick(Sender: TObject);
      begin
      end; //

    procedure TForm1.eClick(Sender: TObject);
      begin
      end; //

    end.

