// u_c_zzz
// 2013-02-09

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_wincontrol_list;
  interface
    uses Generics.Collections, Vcl.Controls;

    type c_wincontrol_list<W : tWinControl> =
             class( tList<W> )
               procedure add_control(p_c_wincontrol: W);
               procedure move_left(p_increment: Integer);
             end; // c_wincontrol_list<W>

  implementation
    uses SysUtils, u_display_simple;


    { c_wincontrol_list<W> }

    procedure c_wincontrol_list<W>.add_control(p_c_wincontrol: W);
      begin
        Add(p_c_wincontrol);
      end; // add_control

    procedure c_wincontrol_list<W>.move_left(p_increment: Integer);
      var l_c_wincontrol: W;
      begin
        for l_c_wincontrol in Self do
          l_c_wincontrol.Left:= l_c_wincontrol.Left+ p_increment;
      end; // move_left

end. // u_c_zzz
